/**
 * NOTE: This class is auto generated by the swagger code generator program (3.0.24).
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */
package io.diebasis.api;

import io.diebasis.model.Poll;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.enums.ParameterIn;
import io.swagger.v3.oas.annotations.responses.ApiResponses;
import io.swagger.v3.oas.annotations.responses.ApiResponse;
import io.swagger.v3.oas.annotations.media.ArraySchema;
import io.swagger.v3.oas.annotations.media.Content;
import io.swagger.v3.oas.annotations.media.Schema;
import io.swagger.v3.oas.annotations.security.SecurityRequirement;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;

import javax.validation.Valid;
import javax.validation.constraints.*;
import java.util.List;

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.SpringCodegen", date = "2021-02-21T21:54:57.554Z[GMT]")
public interface PollApi {

    @Operation(summary = "Add a new poll", description = "", security = {
        @SecurityRequirement(name = "poll_auth", scopes = {
            ""        })    }, tags={ "poll" })
    @ApiResponses(value = { 
        @ApiResponse(responseCode = "405", description = "Invalid input") })
    @RequestMapping(value = "/poll",
        consumes = { "application/json" }, 
        method = RequestMethod.POST)
    ResponseEntity<Void> addPoll(@Parameter(in = ParameterIn.DEFAULT, description = "Poll object that needs to be added", required=true, schema=@Schema()) @Valid @RequestBody Poll body);


    @Operation(summary = "Sets the poll in state archive", description = "", security = {
        @SecurityRequirement(name = "poll_auth", scopes = {
            ""        })    }, tags={ "poll" })
    @ApiResponses(value = { 
        @ApiResponse(responseCode = "204", description = "successful operation"),
        
        @ApiResponse(responseCode = "400", description = "Invalid ID supplied"),
        
        @ApiResponse(responseCode = "404", description = "Poll not found"),
        
        @ApiResponse(responseCode = "409", description = "Poll is already archived") })
    @RequestMapping(value = "/poll/{pollId}",
        method = RequestMethod.DELETE)
    ResponseEntity<Void> archivePoll(@Parameter(in = ParameterIn.PATH, description = "The poll id to archive", required=true, schema=@Schema()) @PathVariable("pollId") Long pollId);


    @Operation(summary = "Finds Polls by status", description = "", security = {
        @SecurityRequirement(name = "poll_auth", scopes = {
            ""        })    }, tags={ "poll" })
    @ApiResponses(value = { 
        @ApiResponse(responseCode = "200", description = "successful operation", content = @Content(array = @ArraySchema(schema = @Schema(implementation = Poll.class)))),
        
        @ApiResponse(responseCode = "400", description = "Invalid status value") })
    @RequestMapping(value = "/poll/findByStatus",
        produces = { "application/json" }, 
        method = RequestMethod.GET)
    ResponseEntity<List<Poll>> findPollsByStatus(@NotNull @Parameter(in = ParameterIn.QUERY, description = "Status values that need to be considered for filter" ,required=true,schema=@Schema(allowableValues={ "draft", "active", "expired", "closed", "archive" }
)) @Valid @RequestParam(value = "status", required = true) String status);


    @Operation(summary = "Find Poll by Id", description = "Returns a single poll", security = {
        @SecurityRequirement(name = "poll_auth", scopes = {
            ""        })    }, tags={ "poll" })
    @ApiResponses(value = { 
        @ApiResponse(responseCode = "200", description = "successful operation", content = @Content(schema = @Schema(implementation = Poll.class))),
        
        @ApiResponse(responseCode = "400", description = "Invalid ID supplied"),
        
        @ApiResponse(responseCode = "404", description = "Poll not found") })
    @RequestMapping(value = "/poll/{pollId}",
        produces = { "application/json" }, 
        method = RequestMethod.GET)
    ResponseEntity<Poll> getPollById(@Parameter(in = ParameterIn.PATH, description = "ID of poll to return", required=true, schema=@Schema()) @PathVariable("pollId") Long pollId);


    @Operation(summary = "Update an existing, not active poll", description = "", security = {
        @SecurityRequirement(name = "poll_auth", scopes = {
            ""        })    }, tags={ "poll" })
    @ApiResponses(value = { 
        @ApiResponse(responseCode = "400", description = "Invalid ID supplied"),
        
        @ApiResponse(responseCode = "404", description = "Poll not found"),
        
        @ApiResponse(responseCode = "405", description = "Validation exception") })
    @RequestMapping(value = "/poll",
        consumes = { "application/json" }, 
        method = RequestMethod.PUT)
    ResponseEntity<Void> updatePoll(@Parameter(in = ParameterIn.DEFAULT, description = "Poll object with updated data for the poll", required=true, schema=@Schema()) @Valid @RequestBody Poll body);


    @Operation(summary = "Updates a poll, when in draft mode", description = "", security = {
        @SecurityRequirement(name = "poll_auth", scopes = {
            ""        })    }, tags={ "poll" })
    @ApiResponses(value = { 
        @ApiResponse(responseCode = "200", description = "successful operation", content = @Content(schema = @Schema(implementation = Poll.class))),
        
        @ApiResponse(responseCode = "403", description = "Update of poll is forbidden, maybe not in status draft"),
        
        @ApiResponse(responseCode = "404", description = "Poll not found"),
        
        @ApiResponse(responseCode = "405", description = "Invalid input") })
    @RequestMapping(value = "/poll/{pollId}",
        produces = { "application/json" }, 
        consumes = { "application/json" }, 
        method = RequestMethod.PUT)
    ResponseEntity<Poll> updatePollById(@Parameter(in = ParameterIn.PATH, description = "ID of poll that needs to be updated", required=true, schema=@Schema()) @PathVariable("pollId") Long pollId, @Parameter(in = ParameterIn.DEFAULT, description = "Poll object that needs to be added", required=true, schema=@Schema()) @Valid @RequestBody Poll body);

}

